{ Copyright (c) 2000 by Mandys Tomas - Mandy Soft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit ibframe;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Grids, DBGrids, ExtCtrls, Db, IBCustomDataSet, IBTable,
  Menus, IBUpdateSQL, IBQuery;

type
  TFrame1 = class(TFrame)
    Table: TIBTable;
    Panel1: TPanel;
    Panel3: TPanel;
    Splitter2: TSplitter;
    DBGrid: TDBGrid;
    DBMemo1: TDBMemo;
    Panel4: TPanel;
    IndexComboBox: TComboBox;
    Edit1: TEdit;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    PopupMenu1: TPopupMenu;
    Newtable1: TMenuItem;
    N4: TMenuItem;
    Search1: TMenuItem;
    N1: TMenuItem;
    Memoonoff1: TMenuItem;
    Countfield1: TMenuItem;
    Fillfieldinrecords1: TMenuItem;
    FieldsSubMenu: TMenuItem;
    FindDialog: TFindDialog;
    IBUpdateSQL1: TIBUpdateSQL;
    procedure TableAfterOpen(DataSet: TDataSet);
    procedure IndexComboBoxChange(Sender: TObject);
    procedure Memoonoff1Click(Sender: TObject);
    procedure DBGridColEnter(Sender: TObject);
    procedure FieldsSubMenuClick(Sender: TObject);
    procedure Countfield1Click(Sender: TObject);
    procedure Fillfieldinrecords1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Search1Click(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure TableAfterClose(DataSet: TDataSet);
    procedure Newtable1Click(Sender: TObject);
  private
    Found: Boolean;
    FindFlag: Byte;
    procedure SetRO(En: Boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

resourcestring
  sInput = 'Input';
  scfMask = 'Counting mask (Format procedure mask with one %d parameter)';
  scfStart = 'Start number';
  scfInc = 'Increment';
  scfCount = 'Count (-1..infinity)';
  sfrString = 'String';
implementation
uses
  ibbrowfr, AuxStr;

{$R *.DFM}

procedure TFrame1.TableAfterOpen(DataSet: TDataSet);
const
  But= [nbEdit, nbPost, nbCancel];
  MaxWidth = 35;
var
  I: Integer;
  MI: TMenuItem;
  S1, S2: string;
begin
  if Table.ReadOnly then DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons-But
                    else DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons+But;
  DBNavigator1.Width:= 10; { adjust width }
  for I:= 0 to Table.FieldCount-1 do
    if Table.Fields[I].DisplayWidth > MaxWidth then
      Table.Fields[I].DisplayWidth:= MaxWidth;
  while FieldsSubMenu.Count > 0 do
    FieldsSubMenu.Delete(0);
  for I:= 0 to Table.FieldCount-1 do
  begin
    MI:= TMenuItem.Create(Self);
    MI.Caption:= Table.Fields[I].FieldName;
    MI.Checked:= Table.Fields[I].Visible;
    MI.OnClick:= FieldsSubMenuClick;
    FieldsSubMenu.Add(MI);
  end;
  FieldsSubMenu.Enabled:= Table.FieldCount <> 0;
  IndexComboBox.Items.Clear;
  Table.GetIndexNames(IndexComboBox.Items);
  IndexComboBox.Items.Insert(0, '<no index>');
  IndexComboBox.ItemIndex:= 0;
  DBGridColEnter(nil);

  S1:= ''; S2:= '';
  for I:= 0 to Table.FieldCount-1 do
  begin
    Table.Fields[I].Required:= False;
  end;
end;

procedure TFrame1.IndexComboBoxChange(Sender: TObject);
begin
  with IndexComboBox do
    if Text[1] = '<' then Table.IndexName:= ''
                     else Table.IndexName:= Text;
end;

procedure TFrame1.Memoonoff1Click(Sender: TObject);
begin
  if DBMemo1.Visible then
    Splitter2.Visible:= False;
  DBMemo1.Visible:= not DBMemo1.Visible;
  if DBMemo1.Visible then
    Splitter2.Visible:= True;
  DBMemo1.AutoDisplay:= DBMemo1.Visible;
end;

procedure TFrame1.DBGridColEnter(Sender: TObject);
begin
  if DBGrid.SelectedField = nil then DBMemo1.DataField:= ''
                                else DBMemo1.DataField:= DBGrid.SelectedField.FieldName;
end;

procedure TFrame1.FieldsSubMenuClick(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked:= not Checked;
    Table.FieldByName(StripHotKey(Caption)).Visible:= Checked;
  end;
end;

procedure TFrame1.Countfield1Click(Sender: TObject);
var
  aStart, aInc, aCount: Integer;
  S, aMask: string;
begin
  aMask:= '%d';
  if not InputQuery(sInput, scfMask, aMask) then
    Exit;
  S:= '1';
  if not InputQuery(sInput, scfStart, S) then
    Exit;
  aStart:= StrToInt(S);
  S:= '1';
  if not InputQuery(sInput, scfInc, S) then
    Exit;
  aInc:= StrToInt(S);
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

    IBBrowserForm.StopFlag:= False;
    while not Table.EOF and not IBBrowserForm.StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= Format(aMask, [aStart]);
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
      Inc(aStart, aInc);
    end;
end;

procedure TFrame1.Fillfieldinrecords1Click(Sender: TObject);
var
  aCount: Integer;
  S, aString: string;
begin
  aString:= '';
  if not InputQuery(sInput, sfrString, aString) then
    Exit;
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

  SetRO(True);
  try
    IBBrowserForm.StopFlag:= False;
    while not Table.EOF and not IBBrowserForm.StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= aString;
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
    end;
  finally
    SetRO(False);
  end;
end;

procedure TFrame1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Return) and (Shift = []) then
  begin
    if (Edit1.Text <> '') and (DBGrid.SelectedField <> nil) then
    begin
      Table.Locate(DBGrid.SelectedField.FieldName, Edit1.Text, [loPartialKey]);
      Key:= 0;
    end;
  end;
end;

procedure TFrame1.Search1Click(Sender: TObject);
begin
  Found:= False;
  FindDialog.Execute;
end;

procedure TFrame1.FindDialogFind(Sender: TObject);
var
  S, S2: string;
  F, F1, F2: Boolean;
  DownS: Boolean;
  function UpC(const S: string): string;
  begin
    Result:= S;
    if not (frMatchCase in FindDialog.Options) then
//      Result:= DBAnsiUpper(Table, Result);
  end;
  procedure Mov;
  begin
    if DownS then Table.Next
             else Table.Prior;
  end;
begin
  if FindFlag <> 0 then
  begin
    IBBrowserForm.StopFlag:= True;
    Exit;
  end;
  IBBrowserForm.StopFlag:= False;
  Inc(FindFlag);
  try
    S:= Trim(UpC(FindDialog.FindText));
    DownS:= frDown in FindDialog.Options;

    if (Length(S) > 1) and (S[1] = '"') and (S[Length(S)] = '"') then
    begin
      Delete(S, 1, 1);
      Delete(S, Length(S), 1);
      F1:= False;
      F2:= False;
    end
  else
    begin
      F1:= S[1] = '*';
      if F1 then Delete(S, 1, 1);
      F2:= S[Length(S)] = '*';
      if F2 then Delete(S, Length(S), 1);
    end;
    if Found then
      Mov;
    repeat
      S2:= UpC(DBGrid.SelectedField.AsString);
      Application.ProcessMessages;
      if not F1 and not F2 then F:= S = S2 else
      if F1 and F2 then F:= Pos(S, S2) > 0 else
      if F2 then F:= S = Copy(S2, 1, Length(S)) else
      if F1 then F:= S = RStr(S2, Length(S));
      Found:= F;
      if F or IBBrowserForm.StopFlag or (DownS and Table.EOF) or (not DownS and Table.BOF) then Break;
      Mov;
    until False;
  finally
    Dec(FindFlag);
  end;
end;


procedure TFrame1.SetRO(En: Boolean);
begin
  DBGrid.Enabled:= not En;
  DBMemo1.Enabled:= not En;
end;

procedure TFrame1.TableAfterClose(DataSet: TDataSet);
begin
  DBGridColEnter(nil);
end;

procedure TFrame1.Newtable1Click(Sender: TObject);
begin
  Table.Close;
  Parent.Free;
  if IBBrowserForm.PageControl1.PageCount = 0 then
    IBBrowserForm.PageControl1.Visible:= False;
end;

end.
